# Thanks to SuperDave who made that pickle thread which syntax is pretty much the same as cPickle
# Again thanks to SuperDave who made the escapelib, it was a great help
# Again, thanks to SuperDave who helped with some nub errors I made

import es, cPickle, os.path, playerlib, popuplib, gamethread, bbankconfig, langlib
from bbankconfig import *


player_data = {}

info = es.AddonInfo() 
info['name']        = "BBank" 
info['version']     = "4.8" 
info['author']      = "Bonbon AKA: Bonbon367" 
info['url']         = "http://addons.eventscripts.com/addons/view/bbank" 
info['description'] = "A Bank With lots more features" 

first_round = 2
es.ServerVar('bbank_version', info['version'], 'BBank made by Bonbon AKA Bonbon367').makepublic()
round_ended = 0
map_ended = 0

dict_saycommands = {
	'!bank': {'block': 'showmenu', 'description': 'Show the main bank menu'},
	'!deposit': {'block': 'deposit', 'description': 'Quick deposit command'},
	'!withdraw': {'block': 'withdraw', 'description': 'Quick withdraw command'},
	'!badmin': {'block': 'admin', 'description': 'Show the admin menu'},
	'badmin': {'block': 'admin', 'description': 'Show the admin menu'},
	'bank': {'block': 'showmenu', 'description': 'Show the main bank menu'},
	'deposit': {'block': 'deposit', 'description': 'Quick deposit command'},
	'withdraw': {'block': 'withdraw', 'description': 'Quick withdraw command'},
	'transfer': {'block': 'transfer', 'description': 'Quick transfer command'},
	'!transfer': {'block': 'transfer', 'description': 'Quick transfer command'},
	'give': {'block': 'transfer', 'description': 'Quick transfer command'},
	'loan': {'block': 'loan', 'description': 'Quick loan command'},
	'!loan': {'block': 'loan', 'description': 'Quick loan command'},
	'repay': {'block': 'repay', 'description': 'Quick repay command'},
	'!repay': {'block': 'repay', 'description': 'Quick repay command'},
}

dict_clientcommands = {
	'cash': {'block': 'givecash', 'description': 'None'},
	'abalance': {'block': 'abalance', 'description': 'Always have x amount of cash in the bank'}
}

text = None
enabled = 1

def load2():
	global text
	if os.path.isfile(es.getAddonPath('bbank') + '/strings.ini'):
		text = langlib.Strings(es.getAddonPath('bbank') + '/strings.ini')
	for client_command in dict_clientcommands:
		if not es.exists('clientcommand', client_command):
			es.regclientcmd(client_command, 'bbank/%s'%dict_clientcommands[client_command]['block'], dict_clientcommands[client_command]['description'])
	for saycommand in dict_saycommands:
		if not es.exists('saycommand', saycommand):
			es.regsaycmd(saycommand, 'bbank/%s'%dict_saycommands[saycommand]['block'], dict_saycommands[saycommand]['description'])
		if not es.exists('clientcommand', saycommand):
			es.regclientcmd(saycommand, 'bbank/%s'%dict_saycommands[saycommand]['block'], dict_saycommands[saycommand]['description'])
	mainmenu = popuplib.easymenu('BBank', '_popup_choice', main_menu_select)
	depositmenu = popuplib.easymenu('Deposit', '_popup_choice', deposit_select)
	withdrawmenu = popuplib.easymenu('Withdraw', '_popup_choice', withdraw_select)
	transfermenu = popuplib.easymenu('Transfer', '_popup_choice', transfer_select)
	adminmenu = popuplib.easymenu('Admin Menu', '_popup_choice', admin_select)
	playerinfo = popuplib.easymenu('Player Info', '_popup_choice', pinfo_select)
	settings = popuplib.easymenu('Settings', '_popup_choice', settings_select)
	accounttype = popuplib.easymenu('Chose New Account', '_popup_choice', account_type_select)
	adminmenu.addoption('Give/Take Cash', 'Give/Take Cash')
	adminmenu.addoption('Reset', 'Reset BBank')
	adminmenu.addoption('Change Player Accounts', 'Change Player Accounts')
	confirmmenu = popuplib.easymenu('Are You Sure?', '_popup_choice', confirm_reset)
	confirmmenu2 = popuplib.easymenu('Reset Account?', '_popup_choice', confirm_reset_2)
	loanmenu = popuplib.easymenu('Loan Menu', '_popup_choice', loan_select)
	loanmoney = popuplib.easymenu('Loan', '_popup_choice', loan_money)
	repaymoney = popuplib.easymenu('Repay', '_popup_choice', repay_money)
	loanmenu.addoption('Loan', 'Loan')
	loanmenu.addoption('Repay', 'Repay')
	for confirm_option in ('Yes', 'No'):
		confirmmenu.addoption(confirm_option, confirm_option)
		confirmmenu2.addoption(confirm_option, confirm_option)
	for b in ('All', '1000', '2000', '4000', '8000', '10000', '14000'):
		depositmenu.addoption(b, b)
		withdrawmenu.addoption(b, b)
		loanmoney.addoption(b, b)
		repaymoney.addoption(b, b)
	for main_options in ('Show Balance', 'Transfer', 'Deposit', 'Withdraw', 'Top', 'Player Info', 'Settings'):
		mainmenu.addoption(main_options, text(main_options))
	if bbank_enable_loan:
		mainmenu.addoption('Loan Menu', text('Loan Menu'))
	for to_sub in (depositmenu, withdrawmenu, settings, transfermenu, playerinfo):
		to_sub.submenu(0, 'BBank')
	confirmmenu2.submenu(0, 'Settings')
	confirmmenu.submenu(0, 'Admin Menu')
	for settings_option in ('Auto Balance', 'Reset Account', 'Sounds'):
		settings.addoption(settings_option, settings_option)
	player_db = es.getAddonPath('bbank') + '/player_info.db'
	if os.path.isfile(player_db):
		global player_data
		player_cash = open(player_db)
		player_data = cPickle.load(player_cash)
		player_cash.close()
	es.msg('#multi', '%s Loaded - Made by Bonbon: AKA Bonbon367'%tell_format)
	enabled_check()
	sound_check()

def sound_check():
	if bbank_enable_sounds:
		es.stringtable('downloadables', 'sound/bbank/withdraw.wav')
		es.stringtable('downloadables', 'sound/bbank/deposit.wav')

def enabled_check():
	global enabled
	enabled = 1
	for prefix in disabled_map_prefixes:
		if str(es.ServerVar('eventscripts_currentmap')).startswith(prefix):
			enabled = 0
			break

def unload():
	for command in dict_clientcommands:
		if es.exists('clientcommand', command):
			es.unregclientcmd(command)
	for saycommand in dict_saycommands:
		if es.exists('saycommand', saycommand):
			es.unregclientcmd(saycommand)
	save_data()
	es.msg('#multi', '%s Unloaded - Made by Bonbon: AKA Bonbon367'%tell_format)

def player_activate(ev):
	steamid = ev['es_steamid']
	if player_data.has_key(steamid):
		global player_data
		bank(ev['userid'], ev['es_steamid']).intrest('player_activate', 'coming back to the server')
		player_data[steamid]['name'] = ev['es_username']
	else:
		bank(ev['userid'], steamid).create()

def es_map_start(ev):
	global first_round, map_ended
	map_ended = 0; first_round = 0
	for userid in playerlib.getUseridList('#all'):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('map_start', 'The map starting')
	enabled_check(); sound_check()

def round_end(ev):
	save_data()
	for userid in playerlib.getUseridList('#human'): 
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_end', 'the round ending')
		bank(userid, playerlib.getPlayer(userid).get('steamid')).loan_intrest()
	if ev['winner'] == '2': filter = '#t'
	elif ev['winner'] == '3': filter = '#ct'
	else: filter = '#all'
	for userid in playerlib.getUseridList(filter):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_won', 'winning the round')
	for userid in playerlib.getUseridList('#alive'):
		bank(userid, playerlib.getPlayer(userid).get('steamid')).intrest('round_survived', 'surviving the round')
	if first_round <= 1:
		global first_round
		first_round += 1
	global round_ended
	round_ended = 1

def bomb_defused(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_defuse', 'defusing the bomb')

def bomb_planted(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_plant', 'planting the bomb')

def bomb_exploded(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('bomb_explode', 'the bomb exploding')

def hostage_rescued(ev):
	bank(ev['userid'], ev['es_steamid']).intrest('hostage_rescue', 'rescuing a hostage')

def round_start(ev):
	global player_data
	global round_ended
	round_ended = 0
	for a in playerlib.getUseridList('#all'):
		player_data[playerlib.getPlayer(a).get('steamid')]['withdraws'] = 0
		player_data[playerlib.getPlayer(a).get('steamid')]['loans'] = account_types[player_data[playerlib.getPlayer(a).get('steamid')]['type']]['max_loans']

class bank:
	def __init__(self, userid, steamid):
		self.userid = userid
		self.steamid = steamid
		self.check_keys()

	def deposit(self, amount):
		amount = abs(amount)
		tokens = {}
		tokens['tell_format'] = tell_format
		self.check_keys()
		if enabled:
			if not round_ended or map_ended:
				global player_data
				if self.steamid != 'BOT':
					if playerlib.getPlayer(self.userid).get('cash') >= amount:
						if player_data[self.steamid]['loan_amount']:
							amount = min(player_data[self.steamid]['loan_amount'], amount)
							es.cexec(self.userid, 'repay %s'%amount)
						else:
							amount = amount if player_data[self.steamid]['cash'] + amount <= account_types[player_data[self.steamid]['type']]['max_balance'] or account_types[player_data[self.steamid]['type']]['max_balance'] == 0 else account_types[player_data[self.steamid]['type']]['max_balance'] - player_data[self.steamid]['cash']
							if player_data[self.steamid]['cash'] + amount <= account_types[player_data[self.steamid]['type']]['max_balance'] or account_types[player_data[self.steamid]['type']]['max_balance'] == 0 and amount > 0:
								player_data[self.steamid]['cash'] += int(amount)
								playerlib.getPlayer(self.userid).set('cash', int(playerlib.getPlayer(self.userid).get('cash')) - int(amount))
								tokens['amount'] = int(amount)
								tokens['balance'] = int(player_data[self.steamid]['cash'])
								es.tell(self.userid, '#multi', text('deposit', tokens, playerlib.getPlayer(self.userid).get('lang')))
								if player_data[self.steamid]['Sounds']: es.cexec(self.userid, 'play bbank/deposit')
							else:
								es.tell(self.userid, '#multi', text('max balance', tokens, playerlib.getPlayer(self.userid).get('lang')))
					else:
						tokens['amount'] = int(amount)
						es.tell(self.userid, '#multi', text('cant deposit', tokens, playerlib.getPlayer(self.userid).get('lang')))
				else:
					es.tell(self.userid, '#green', ':) :( :O O: :D T_T @_@ :o o: xD >.> >.< <.<')
			else:
				es.tell(self.userid, '#multi', '%sWHAT NAO!?'%tell_format)
		else:
			es.tell(self.userid, '#multi', text('disabled', tokens, playerlib.getPlayer(self.userid).get('lang')))

	def transfer(self, target_userid, target_steamid, amount):
		tokens = {}
		tokens['tell_format'] = tell_format
		self.check_keys()
		global player_data
		if self.steamid != 'BOT' and target_steamid != 'BOT':
			if amount > 0 and amount <= player_data[self.steamid]['cash']:
				player_data[self.steamid]['cash'] -= amount
				player_data[target_steamid]['cash'] += amount
				tokens['amount'] = int(amount)
				tokens['giver'] = playerlib.getPlayer(self.userid).get('name')
				tokens['target'] = playerlib.getPlayer(target_userid).get('name')
				es.tell(target_userid, '#multi', text('transfer recieve', tokens, playerlib.getPlayer(target_userid).get('lang')))
				es.tell(self.userid, '#multi', text('transfer send', tokens, playerlib.getPlayer(self.userid).get('lang')))

	def withdraw(self, amount):
		tokens = {}
		tokens['tell_format'] = tell_format
		global player_data
		self.check_keys()
		if self.steamid != 'BOT':
			if player_data[self.steamid]['cash'] >= amount:
				if first_round > 1 or withdraw_on_first_round == 1:
					if player_data[self.steamid]['withdraws'] < account_types[player_data[self.steamid]['type']]['max_withdraws'] or account_types[player_data[self.steamid]['type']]['max_withdraws'] == 0:
						if playerlib.getPlayer(self.userid).get('cash') + int(amount) <= 16000:
							player_data[self.steamid]['cash'] -= int(amount)
							playerlib.getPlayer(self.userid).set('cash', int(playerlib.getPlayer(self.userid).get('cash')) + int(amount))
							player_data[self.steamid]['withdraws'] += 1
							tokens['amount'] = int(amount)
							tokens['balance'] = int(player_data[self.steamid]['cash'])
							es.tell(self.userid, '#multi', text('withdraw', tokens, playerlib.getPlayer(self.userid).get('lang')))
							if player_data[self.steamid]['Sounds']: es.cexec(self.userid, 'play bbank/withdraw')
						else:
							es.tell(self.userid, '#multi', text('cant withdraw', tokens, playerlib.getPlayer(self.userid).get('lang')))
					else:
						es.tell(self.userid, '#multi', text('no withdraws', tokens, playerlib.getPlayer(self.userid).get('lang')))
				else:
					es.tell(self.userid, '#multi', text('first round withdraw', tokens, playerlib.getPlayer(self.userid).get('lang')))
			else: 
				tokens['amount'] = int(amount)
				es.tell(self.userid, '#multi', text('no money withdraw', tokens, playerlib.getPlayer(self.userid).get('lang')))
		else:
			es.tell(self.userid, '#green', 'Wagga wagga wagga PFFFFFT WHREEEEEEEEEEEET')

	def intrest(self, event, message):
		tokens = {}
		tokens['tell_format'] = tell_format
		global player_data
		if self.steamid != 'BOT':
			if player_data[self.steamid].has_key('intrest'):
				player_data[self.steamid]['cash'] *= 1 + intrest_rates[event]
				if player_data[self.steamid]['cash'] * (intrest_rates[event] * account_types[player_data[self.steamid]['type']]['intrest_multiplier']) > 5:
					if bbank_tell_every_intrest == 1:
						tokens['amount'] = int(player_data[self.steamid]['cash'] * (intrest_rates[event] * account_types[player_data[self.steamid]['type']]['intrest_multiplier']))
						tokens['reason'] = message
						if player_data[self.steamid]['cash'] * (1 + intrest_rates[event]) >= bbank_min_intrest_tell:
							es.tell(self.userid, '#multi', text('intrest', tokens, playerlib.getPlayer(self.userid).get('lang')))
					else:
						player_data[self.steamid]['intrest'] = intrest_rates[event] * player_data[self.steamid]['cash']
			else:
				player_data[self.steamid]['intrest'] = 0

	def create(self):
		global player_data
		player_data[self.steamid] = {}
		player_data[self.steamid]['cash'] = start_cash
		player_data[self.steamid]['name'] = playerlib.getPlayer(self.userid).attributes['name']
		player_data[self.steamid]['withdraws'] = 0
		player_data[self.steamid]['abalance'] = 0
		player_data[self.steamid]['intrest'] = 0
		player_data[self.steamid]['type'] = 'Default'
		player_data[self.steamid]['loans'] = account_types['Default']['max_loans']
		player_data[self.steamid]['loan_amount'] = 0
		player_data[self.steamid]['Sounds'] = bbank_enable_sounds
		tokens = {}
		tokens['tell_format'] = tell_format
		es.tell(self.userid, '#multi', text('create', tokens, playerlib.getPlayer(self.userid).get('lang')))

	def abalance(self):
		if player_data[self.steamid]['abalance']:
			if playerlib.getPlayer(self.userid).get('cash') > player_data[self.steamid]['abalance']:
				self.deposit(playerlib.getPlayer(self.userid).get('cash') - player_data[self.steamid]['abalance'])
			elif playerlib.getPlayer(self.userid).get('cash') < player_data[self.steamid]['abalance']:
				self.withdraw(int(player_data[self.steamid]['abalance']) - (playerlib.getPlayer(self.userid).get('cash')))
	
	def check_keys(self):
		global player_data
		keys = {'cash': start_cash, 'name': 'unnamed', 'withdraws': 0, 'abalance': 0, 'intrest': 0, 'type': 'Default', 'loans': account_types['Default']['max_loans'], 'loan_amount': 0, 'Sounds': bbank_enable_sounds}
		for a in keys:
			if not player_data[self.steamid].has_key(a):
				player_data[self.steamid][a] = keys[a]

	def loan(self, amount):
		global player_data
		tokens = {}
		tokens['tell_format'] = tell_format
		pd = player_data[self.steamid]
		if first_round > 1 or withdraw_on_first_round == 1:
			if pd['loans']:
				if pd['loan_amount'] <= account_types[pd['type']]['max_loan_total_amount']:
					if int(amount) > 0:
						if playerlib.getPlayer(self.userid).get('cash') + int(amount) <= 16000:
							pd['loan_amount'] += int(amount)
							pd['loans'] -= 1
							tokens['amount'] = int(amount)
							tokens['loan'] = int(pd['loan_amount'])
							es.tell(self.userid, '#multi', text('loan', tokens, playerlib.getPlayer(self.userid).get('lang')))
							playerlib.getPlayer(self.userid).set('cash', playerlib.getPlayer(self.userid).get('cash') + int(amount))
						else:
							es.tell(self.userid, '#multi', text('too much money', tokens, playerlib.getPlayer(self.userid).get('lang')))
					else:
						es.tell(self.userid, '#multi', text('invalid loan value', tokens, playerlib.getPlayer(self.userid).get('lang')))
				else:
					tokens['amount'] = int(account_types[pd['type']]['max_loan_total_amount'])
					es.tell(self.userid, '#multi', text('cant loan', tokens, playerlib.getPlayer(self.userid).get('lang')))
			else:
				es.tell(self.userid, '#multi', text('max loan', tokens, playerlib.getPlayer(self.userid).get('lang')))
		else:
			es.tell(self.userid, '#multi', text('first round withdraw', tokens, playerlib.getPlayer(self.userid).get('lang')))

	def loan_intrest(self):
		global player_data
		if not self.steamid == 'BOT':
			pd = player_data[self.steamid]
			if int(pd['loan_amount']):
				if pd['loan_amount'] <= account_types[pd['type']]['loan_intrest_cap']:
					pd['loan_amount'] = int(pd['loan_amount']) + int(pd['loan_amount'] * (account_types[pd['type']]['loan_intrest_percent'] / 100.0))
					tokens = {}
					tokens['tell_format'] = tell_format
					tokens['amount'] = int(pd['loan_amount'] * (account_types[pd['type']]['loan_intrest_percent'] / 100.0))
					es.tell(self.userid, '#multi', text('loan intrest', tokens, playerlib.getPlayer(self.userid).get('lang')))

	def repay(self, amount):
		global player_data
		tokens = {}
		tokens['tell_format'] = tell_format
		pd = player_data[self.steamid]
		amount = min(player_data[self.steamid]['loan_amount'], playerlib.getPlayer(self.userid).get('cash'))
		if float(pd['loan_amount']) - float(amount) >= 0:
			if int(amount) > 0:
				if playerlib.getPlayer(self.userid).get('cash') - int(amount) >= 0:
					pd['loan_amount'] -= int(amount)
					tokens['amount'] = int(amount)
					tokens['loan'] = int(pd['loan_amount'])
					es.tell(self.userid, '#multi', text('loan payback', tokens, playerlib.getPlayer(self.userid).get('lang')))
					playerlib.getPlayer(self.userid).set('cash', playerlib.getPlayer(self.userid).get('cash') - int(amount))
				else:
					tokens['amount'] = int(amount)
					es.tell(self.userid, '#multi', text('not enough to repay', tokens, playerlib.getPlayer(self.userid).get('lang')))
			else:
				es.tell(self.userid, '#multi', text('invalid loan value', tokens, playerlib.getPlayer(self.userid).get('lang')))
		else:
			tokens['amount'] = int(amount)
			es.tell(self.userid, '#multi', text('loan too big', tokens, playerlib.getPlayer(self.userid).get('lang')))

def showmenu():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	popuplib.send('BBank', userid)
	if not player_data.has_key(steamid):
		bank(userid, steamid).create()

def deposit():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = es.getargv(1)
	if es.getargc() >= 2:
		if amount == 'all':
			amount = playerlib.getPlayer(userid).get('cash')
		else:
			amount = int(amount)
		bank(userid, steamid).deposit(amount)
	else:
		popuplib.send('Deposit', userid)

def withdraw():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = es.getargv(1)
	if es.getargc() >= 2:
		if amount == 'all':
			if player_data[steamid]['cash'] >= 16000 - int(playerlib.getPlayer(userid).get('cash')):
				amount = 16000 - int(playerlib.getPlayer(userid).get('cash'))
			else:
				amount = player_data[steamid]['cash']
			bank(userid, steamid).withdraw(amount)
		else:
			amount = int(amount)
			bank(userid, steamid).withdraw(amount)
	else:
		popuplib.send('Withdraw', userid)

def loan():
	userid = es.getcmduserid()
	amount = es.getargv(1)
	if amount.isdigit():
		amount = int(amount)
	elif amount == 'all':
		amount = 16000 - playerlib.getPlayer(userid).get('cash')
	if str(amount).isdigit():
		bank(userid, playerlib.getPlayer(userid).get('steamid')).loan(amount)
	else:
		es.tell(userid, '#multi', text('invalid amount', {'tell_format': tell_format, 'amount': amount}, playerlib.getPlayer(userid).get('lang')))

def repay():
	userid = es.getcmduserid()
	amount = es.getargv(1)
	if amount.isdigit():
		amount = int(amount)
	elif amount == 'all':
		amount = playerlib.getPlayer(userid).get('cash')
	if str(amount).isdigit():
		bank(userid, playerlib.getPlayer(userid).get('steamid')).repay(amount)
	else:
		es.tell(userid, '#multi', text('invalid amount', {'tell_format': tell_format, 'amount': amount}, playerlib.getPlayer(userid).get('lang')))

def main_menu_select(userid, choice, popupid):
	if choice == 'Transfer':
		transfermenu = popuplib.easymenu('Transfer', '_popup_choice', transfer_select)
		for userid2 in playerlib.getUseridList('#all'):
			transfermenu.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
	elif choice == 'Show Balance':
		tokens = {}
		tokens['tell_format'] = tell_format
		tokens['amount'] = int(player_data[playerlib.getPlayer(userid).get('steamid')]['cash'])
		tokens['loan'] = int(player_data[playerlib.getPlayer(userid).get('steamid')]['loan_amount'])
		es.tell(userid, '#multi', text('querry balance', tokens, playerlib.getPlayer(userid).get('lang')))
	elif choice == 'Top':
		t___t = players_in_top
		top = popuplib.easymenu('Top', '_popup_choice', top_select)
		b = {}
		for l in player_data:
			b[l] = player_data[l]['cash']
		d = sorted(b.iteritems(), key=lambda (k, v): (v, k), reverse=True)
		for e in d:
			t___t -=1
			if t___t >= 0:
				top.addoption(e[0], '%s: %s'%(player_data[e[0]]['name'], int(player_data[e[0]]['cash'])))
	elif choice == 'Player Info':
		playerinfo = popuplib.easymenu('Player Info', '_popup_choice', pinfo_select)
		for userid2 in playerlib.getUseridList('#all'):
			playerinfo.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
	popuplib.send(choice, userid)

def deposit_select(userid, choice, popupid):
	if choice.lower() == 'all':
		amount = int(playerlib.getPlayer(userid).get('cash'))
	else:
		amount = int(choice)
	bank(userid, playerlib.getPlayer(userid).get('steamid')).deposit(amount)

def withdraw_select(userid, choice, popupid):
	if choice.lower() == 'all':
		amount = 16000 - int(playerlib.getPlayer(userid).get('cash'))
	else:
		amount = int(choice)
	bank(userid, playerlib.getPlayer(userid).get('steamid')).withdraw(amount)

def loan_select(userid, choice, popupid):
	popuplib.send(choice, userid)

def loan_money(userid, choice, popupid):
	es.cexec(userid, 'loan %s'%choice)

def repay_money(userid, choice, popupid):
	es.cexec(userid, 'repay %s'%choice)

def transfer_select(userid, choice, popupid):
	transfermenu2 = popuplib.easymenu('Transfer Amount', '_popup_choice', transfer_select2)
	for a in ('All', '1000', '2000', '4000', '8000', '16000', '20000', '40000'):
		transfermenu2.addoption((choice, a), a)
	popuplib.send('Transfer Amount', userid)

def transfer_select2(userid, choice, popupid):
	steamid = playerlib.getPlayer(userid).get('steamid')
	target_steamid = playerlib.getPlayer(choice[0]).get('steamid')
	amount = choice[1]
	if amount.lower() == 'all':
		amount = player_data[steamid]['cash']
	else:
		amount = int(amount)
	if player_data[steamid]['cash'] >= amount:
		bank(userid, steamid).transfer(choice[0], target_steamid, amount)
	else: 
		tokens = {}
		tokens['tell_format'] = tell_format
		tokens['amount'] = amount
		es.tell(userid, '#multi', text('cant transfer', tokens, playerlib.getPlayer(userid).get('lang')))


def top_select(userid, choice, popupid):
	es.tell(userid, '#multi', '%sSteamID - %s Cash - %s, Last Known Name - %s'%(tell_format, choice, player_data[choice]['cash'], player_data[choice]['name']))

def save_data():
	player_db = open(es.getAddonPath('bbank') + '/player_info.db', 'w')
	cPickle.dump(player_data, player_db)
	player_db.close()

def admin():
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	if steamid in admins:
		if player_data.has_key(steamid):
			popuplib.send('Admin Menu', userid)
		else:
			tokens = {}
			tokens['tell_format'] = tell_format
			es.tell(userid, '#multi', text('admin account', tokens, playerlib.getPlayer(userid).get('lang')))


def admin_select(userid, choice, popupid):
	if choice == 'Give/Take Cash':
		admintake = popuplib.easymenu('Give/Take Cash', '_popup_choice', admingive_select)
		for userid2 in playerlib.getUseridList('#all'):
			admintake.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
		popuplib.send('Give/Take Cash', userid)
	elif choice == 'Reset':
		popuplib.send('Are You Sure?', userid)
	elif choice == 'Change Player Accounts':
		accounttype = popuplib.easymenu('Change Account Types', '_popup_choice', account_type_select)
		for userid2 in playerlib.getUseridList('#all'):
			accounttype.addoption(userid2, playerlib.getPlayer(userid2).attributes['name'])
		popuplib.send('Change Account Types', userid)
		

def admingive_select(userid, choice, popupid):
	global player_data
	es.escinputbox(30, userid, '|-BBank Give/Take Cash-|', 'Please Input a value to Give/Take', 'cash')
	player_data[playerlib.getPlayer(userid).get('steamid')]['target'] = choice
	tokens = {}
	tokens['tell_format'] = tell_format
	es.tell(userid, '#multi', text('input value', tokens, playerlib.getPlayer(userid).get('lang')))

def givecash():
	userid = es.getcmduserid()
	amount = int(es.getargv(1))
	tokens = {}
	tokens['tell_format'] = tell_format
	global player_data
	if playerlib.getPlayer(userid).get('steamid') in admins:
		if player_data[playerlib.getPlayer(userid).get('steamid')].has_key('target'):
			tokens['amount'] = abs(amount)
			if player_data[playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('steamid')]['cash'] + amount >= 0:
				player_data[playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('steamid')]['cash'] += amount
				if amount > 0:
					es.tell(player_data[playerlib.getPlayer(userid).get('steamid')]['target'], '#multi', text('give cash', tokens, playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('lang')))
				else:
					es.tell(player_data[playerlib.getPlayer(userid).get('steamid')]['target'], '#multi', text('take cash', tokens, playerlib.getPlayer(player_data[playerlib.getPlayer(userid).get('steamid')]['target']).get('lang')))
			else:
				es.tell(userid, '#multi', text('cant take cash', tokens, playerlib.getPlayer(userid).get('lang')))
		else:
			es.tell(userid, '#multi', text('select a target', tokens, playerlib.getPlayer(userid).get('lang')))
	else:
		es.tell(userid, '#multi', text('not authorized', tokens, playerlib.getPlayer(userid).get('lang')))

def pinfo_select(userid, choice, popupid):
	steamid = playerlib.getPlayer(choice).get('steamid')
	es.tell(userid, '#multi', '%sSteamID - #lightgreen%s Cash - %s, #greenLast Known Name - %s'%(tell_format, steamid, int(player_data[steamid]['cash']), player_data[steamid]['name']))

def confirm_reset(userid, choice, popupid):
	global player_data
	if choice == 'Yes':
		player_data.clear()
	else:
		es.tell(userid, '#multi', '%sToo bad, reseting anyways'%tell_format)
		gamethread.delayed(3, es.tell, (userid, '#multi', '%sNah, J/K :)'%tell_format))

def transfer():
	tokens = {}
	tokens['tell_format'] = tell_format
	userid = es.getcmduserid()
	target = es.getuserid(es.getargv(1))
	amount = es.getargv(2)
	if amount == 'all':
		amount = int(player_data[playerlib.getPlayer(userid).get('steamid')]['cash'])
	else:
		if '.' in amount:
			if str(amount)[:amount.find('.')].isdigit():
				amount = int(amount[:amount.find('.')])
		elif amount.isdigit():
				amount = int(amount)
		else:
			tokens['amount'] = amount
			es.tell(userid, '#multi', text('invalid amount', tokens, playerlib.getPlayer(userid).get('lang')))
	if target:
		bank(userid, playerlib.getPlayer(userid).get('steamid')).transfer(target, playerlib.getPlayer(target).get('steamid'), amount)
	else:
		es.tell(userid, '#multi', text('invalid player', tokens, playerlib.getPlayer(userid).get('lang')))

def settings_select(userid, choice, popupid):
	if choice == 'Auto Balance':
		es.escinputbox(30, userid, '|-BBank Auto Balance-|', 'Please Input a value to auto have', 'abalance')
		es.tell(userid, '#multi', '%sPress escape on your keyboard to input a value to auto withdraw/deposit 0 == disabled'%tell_format)
	elif choice == 'Reset Account':
		popuplib.send('Reset Account?', userid)
	elif choice == 'Sounds':
		tokens = {}
		if bbank_enable_sounds:
			global player_data
			tokens['tell_format'] = tell_format
			tokens['toggle'] = 'off' if player_data[es.getplayersteamid(userid)]['Sounds'] else 'on'; player_data[es.getplayersteamid(userid)]['Sounds'] = 0 if player_data[es.getplayersteamid(userid)]['Sounds'] else 1
			es.tell(userid, '#multi', text('sound toggle', tokens, playerlib.getPlayer(userid).get('lang')))
		else:
			es.tell(userid, '#multi', text('sound off', tokens, playerlib.getPlayer(userid).get('lang')))
		
def confirm_reset_2(userid, choice, popupid):
	if choice == 'Yes':
		global player_data
		player_data[playerlib.getPlayer(userid).get('steamid')]['cash'] = 0

def abalance():
	tokens = {}
	tokens['tell_format'] = tell_format
	userid = es.getcmduserid()
	steamid = playerlib.getPlayer(userid).get('steamid')
	amount = int(es.getargv(1))
	if amount >= 0 and amount <= 16000:
		global player_data
		player_data[steamid]['abalance'] = amount
		tokens['amount'] = amount
		es.tell(userid, '#multi', text('abalance', tokens, playerlib.getPlayer(userid).get('lang')))
		es.tell(userid, '#multi', '%sYou will now automatically have #lightgreen%s #greencash on spawn!'%(tell_format, amount))
	else:
		es.tell(userid, '#multi', '%sPlease input a value below 16000 and above -1! 0 == disabled'%tell_format)

def player_spawn(ev):
	if player_data.has_key(ev['es_steamid']):
		bank(ev['userid'], ev['es_steamid']).check_keys()
		gamethread.delayed(0.1, bank(ev['userid'], ev['es_steamid']).abalance, args=())
		global player_data
		if not bbank_tell_every_intrest and player_data[ev['es_steamid']]['intrest'] >= bbank_min_intrest_tell:
			es.tell(ev['userid'], '#multi', '%sYou have gained a total of #lightgreen%s#green dollars from last round!'%(tell_format, int(player_data[ev['es_steamid']]['intrest'])))
		player_data[ev['es_steamid']]['intrest'] = 0
	else:
		bank(ev['userid'], ev['es_steamid']).create()
def account_type_select(userid, choice, popupid):
	accounttypemenu2 = popuplib.easymenu('Chose New Account', '_popup_choice', account_type_select2)
	for a in account_types:
		accounttypemenu2.addoption((choice, a), a)
	popuplib.send('Chose New Account', userid)

def account_type_select2(userid, choice, popupid):
	tokens = {}
	tokens['tell_format'] = tell_format
	steamid = playerlib.getPlayer(userid).get('steamid')
	target_steamid = playerlib.getPlayer(choice[0]).get('steamid')
	type = choice[1]
	if player_data.has_key(target_steamid):
		global player_data
		player_data[target_steamid]['type'] = type
		tokens['type'] = type
		tokens['target'] = playerlib.getPlayer(choice[0]).get('name')
		es.tell(userid, '#multi', text('admin change account', tokens, playerlib.getPlayer(userid).get('lang')))
		es.tell(choice[0], '#multi', text('change account', tokens, playerlib.getPlayer(userid).get('lang')))
	else: 
		es.tell(userid, '#multi', text('no account', tokens, playerlib.getPlayer(userid).get('lang')))

def est_map_end(ev):
	global map_ended
	map_ended = 1
	if bbank_auto_deposit_on_map_end:
		for userid in es.getUseridList():
			bank(userid, playerlib.getPlayer(userid).get('steamid')).deposit(playerlib.getPlayer(userid).get('cash'))

gamethread.delayed(0, load2, ())